
/*The #include directive treats
text in the file specified by
filename as if it appeared in the
current file.*/

#include <windows.h>
#include <stdio.h>
#include <jni.h>

//The #define directive defines a macro.
#define MAIN_CLASS  "MyFrame"

//Entry point
int APIENTRY WinMain(HINSTANCE hInstance, 
		HINSTANCE hPrevInstance, 
		    LPSTR lpCmdLine, int nCmdShow)
{
    
  JNIEnv*        env;
  JavaVMOption options[1];
  JavaVM*        jvm;
  JavaVMInitArgs vm_args;
  long           status;
  jclass         cls;
  jmethodID      mainId;
  
  options[0].optionString = "-Djava.class.path=.";
  
  memset(&vm_args, 0, sizeof(vm_args));
   vm_args.version = JNI_VERSION_1_2;
   vm_args.nOptions = 1;
   vm_args.options = options;
  
  /* create the JVM */
  status = JNI_CreateJavaVM( 
	       &jvm, (void**)&env, &vm_args );  
  
  //Error
  if( status == JNI_ERR )
     return 1;

  /* load the class containing 
   the static main() method */
  cls = (*env)->FindClass( env, MAIN_CLASS );
   
  
  /* find the main() method */
  mainId = (*env)->GetStaticMethodID(
	      env, cls, "main", "([Ljava/lang/String;)V");
  
  /* call main() */
  (*env)->CallStaticVoidMethod(env, cls, mainId, 0); 
  
  /* kill the JVM */
  (*jvm)->DestroyJavaVM( jvm ); 
  
  return 0;
}
